/****************************************************************************
*
*            COPYRIGHT 1990,91,92 BY GRACILIS INC.
*
*			 623 Palace St.
*			 Aurora, Il. 60506
*
*			 (708)-801-8800		Office
*			 (708)-844-0183		(FAX - Support BBS)
*
* GRACILIS, INC., MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS 
* SOFTWARE FOR ANY PURPOSE.  
*
* THIS SOFTWARE IS PROVIDED "AS IS" WITHOUT EXPRESS OR IMPLIED WARRANTY.
* 
* Permission is granted for non-commercial use/distribution only, as long as
* this copyright header is included intact and unaltered.
*
******************************************************************************/

#undef DEBUG 1

#include <stdio.h>
#include <string.h>
#include <time.h>
#include <sys/timeb.h>

#include "global.h"
#include "gcallbk.h"

extern	char	*CDBname;		/* Filename to use */
extern	int		CDBtype;		/* Type of callbook database to expect */

static int 	days_tbl[13] = { 0, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

char		cbuffer[256];
CALLREC 	current_rec;
struct tm 	st_time;


long		lasthi,lastlo,current;


extern char *get_field();
extern fill_record();
extern long calc_nxt_record();
extern strnicmp();
static void format_date __ARGS((struct tm *st_time,char *day_str));
static void free_record __ARGS((CALLREC *record));
static void show_record	__ARGS((CALLREC *current_rec,int s));


void
cb_lookup(s,call)
int	s;
char	*call;
{
FILE	*fp;
char	*file;		/* derived file name */
int		sts;
int		dir,srch;
char	search_call[10];
int		srch_cnt = 0;
char	thiscall[8];
int	srch_len= 0;
char	*tmp;
char	*convert_call();

	if(CDBtype == BUCKMASTER)
	{

		/* Init the search call to all spaces */
		strcpy(search_call,"      ");	

		tmp = convert_call(call);		/* format the search call in  */
										/* accordance with that required by */
										/* the BUCKMASTER database */

		strncpy(search_call,tmp,strlen(tmp)); /* build our search string */

		free(tmp);						/* Free the string that was allocated */
										/* by convert_call */

	}

	/* Else if it is an FCC style Database */
	else
	{

		/* For the FCC formatted database things are easier... */
		/* only right added with blanks... 8-) */

		/* Init the search call to all spaces */
		strcpy(search_call,"      ");	
		srch_len = strlen(call);
		strncpy(search_call,call,srch_len);
	}


#ifdef DEBUG
	tprintf("Opening database: %s\n",CDBname);
#endif

	if((fp = fopen(CDBname,READ_TEXT)) == NULLFILE)
	{
		usprintf(s,"\n*** %s ***: Callbook Database is Offline.\n",Hostname);
		return;
	}

	/* position to end of file */
	fseek(fp,0L,2L);
	lasthi = ftell(fp);

#ifdef DEBUG
	usprintf(s,"lasthi %ld\n",lasthi);
#endif

	lastlo = 0;
	current = lasthi/2; 

	fgets(cbuffer,256,fp);
	cbuffer[0] = '\0';

	
	while(current >= 0)
	{
#ifdef DEBUG 
		usprintf(s,"Position: %d\n",current);
#endif
		pwait(NULL);		/* give up the processor for others to run */

		sts = find_next_rec(fp,current,cbuffer);
		if(sts)
		{
			usprintf(s,"Error reading database\n");
			fclose(fp);
			return;
		}

		srch_cnt++;

		/* different matching criteria for each database format */
		/* are handled in chk4match */

		srch = chk4match(search_call,cbuffer);


#ifdef DEBUG
		strncpy(thiscall,cbuffer,6);
		thiscall[6] = '\0';
		usprintf(s,"srch: %s    currec: %s\n",search_call,thiscall);
#endif

		if(srch== 0)
		{

			memset(&current_rec,'\0',sizeof(struct callrec));

			if(CDBtype == BUCKMASTER)
				sts = buck_fill_record(cbuffer,&current_rec);
			else
				sts = fcc_fill_record(cbuffer,&current_rec);

			if(sts == 0)
			{
				show_record(&current_rec,s);
			}
			else
			{
				usprintf(s,"Internal Database Error!\n");
			}

			usprintf(s,"\nSearch Count: %d\n\n",srch_cnt);
			
			free_record(&current_rec);
			fclose(fp);
			return;
		}

		else
		{
			if(srch < 0) 
			{
				dir = LOWER;
#ifdef DEBUG 
		strncpy(thiscall,cbuffer,6);
		thiscall[6] = '\0';
		usprintf(s,"Nomatch: %s    TRY LOWER\n",thiscall);
#endif
			}
			if(srch > 0) 
			{
				dir = HIGHER;
#ifdef DEBUG 
		strncpy(thiscall,cbuffer,6);
		thiscall[6] = '\0';
		usprintf(s,"Nomatch: %s    TRY HIGHER\n",thiscall);
#endif
			}
			current = calc_nxt_record(dir);
		}
	}

	usprintf(s,"Record not found!\n");		
	usprintf(s,"Search Count: %d\n",srch_cnt);
	fclose(fp);

}

/* seek to file position "pos" then find start of next record */

find_next_rec(fp,pos,buffer) 
FILE	*fp; 
long pos;
char	*buffer;
{

	/* go to the right place in the file */
	/* if error then exit */		

	if(fseek(fp,pos,0L) != 0) return -1;

	/* get and toss any partial record */
	if(pos != 0)fgets(buffer,256,fp);

	/* now get next complete record */
	fgets(buffer,256,fp);
	
	return 0;

}	



/* here disect an input string into it's component parts */
fcc_fill_record(buffer,record)
char	*buffer;
CALLREC *record;
{
char	fldbuf[256];
char	*tmpbuf;
int	sts;

    sts = -1;		/* default to fail */
    tmpbuf = buffer;
	
    while(1)
    {
	
	/* get the data fields... and expand as neccessary */		
	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;

	/* get the callsign */
	if(strlen(fldbuf))record->call = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->last_name = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->title = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->first_name = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->middle_name = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->birth_date = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->license_date = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->expire_date = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->mail_addr1 = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->mail_city = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->mail_state = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->zip = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->location1 = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->location2 = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->location3 = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->license_class = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->prev_call = strdup(fldbuf);

	if((tmpbuf = get_field(tmpbuf,fldbuf)) == NULL) break;
	if(strlen(fldbuf))record->prev_class = strdup(fldbuf);

	get_field(tmpbuf,fldbuf);
	if(strlen(fldbuf)) record->extra = strdup(fldbuf);
	sts = 0;
    }	


    return sts;

}


/* given input buffer, pull out the next field, copying data into specified */
/* field, and return pointer to beginning of next field... skipping over */
/* the "BAR".  Return NULL for no more fields */

char *
get_field(buffer,field)
char	*buffer;
char	*field;
{

char 	*bar;
int	field_len;
int	blnklen = 0;

	field[0] = '\0';	/* initially null terminate the string */

	/* find the "BAR" separator field */
	bar = strchr(buffer,'|');

	if(bar != NULL)
	{
		field_len = (int)(bar - buffer);

		if(field_len)
		{
			blnklen = strspn(buffer," ");
			strncpy(field,buffer+blnklen,field_len-blnklen);

		field[field_len-blnklen] = '\0';	/* terminate the string */
		}

		/* bump pointer past the "BAR" */
		bar +=1;
	}	
	else
	{
		field_len = strlen(buffer);
		blnklen = strspn(buffer," ");
		strncpy(field,buffer+blnklen,field_len-blnklen);
		field[field_len-blnklen] = '\0';   /* terminate the string */
	}	
	return bar;
}

long
calc_nxt_record(dir)
int dir;
{
long	new;

	if(dir == LOWER)
	{
		lasthi = current;
		if(current == 1 )new = 0;
		else new = current - ((current - lastlo)/2);	
	}	

	if(dir == HIGHER)
	{
		lastlo = current;
		new = current + ((lasthi-current)/2);
	}

	if(new == current)new = -1;

	return new;
}


#ifdef BSD

/* Case-insensitive string comparison */
strnicmp(a,b,n)
register char *a,*b;
register int n;
{
	char a1,b1;

	while(n-- != 0 && (a1 = *a++) != '\0' && (b1 = *b++) != '\0'){
		if(a1 == b1)
			continue;	/* No need to convert */
		a1 = tolower(a1);
		b1 = tolower(b1);
		if(a1 == b1)
			continue;	/* NOW they match! */
		if(a1 > b1)
			return 1;
		if(a1 < b1)
			return -1;
	}
	return 0;
}

#endif



static void
format_date(st_time,day_str)
struct	tm	*st_time;
char	*day_str;
{
	sprintf(day_str,"%1d/%1d/%2d",
			st_time->tm_mon,
			st_time->tm_mday,
			st_time->tm_year);
}



/*
 * Fills the  time/date structure from supplied DAY of YEAR
 */
month_day_year(year,dayno,st_time)
unsigned year,dayno;
struct tm *st_time;
{
int i;
unsigned leap,days;
unsigned month;
unsigned days_in_year, cur_days_in_cur_month;


	days = dayno;

	if ((year % 4) == 0) 
		leap = TRUE;
	else  
		leap = FALSE;

	month = 1; 
	
	cur_days_in_cur_month = days_tbl[1];

	/* now add in the days for previous months in this year */
	while ( days > cur_days_in_cur_month )
	{
		/* next month */
		month++;

		/* remaining days in year */
		days -= cur_days_in_cur_month;

		/* get current month's days */
		cur_days_in_cur_month = days_tbl[month];

		if ( (month == 2) && (leap) )
			cur_days_in_cur_month++; 
	}
		
	if ( days == 0 )
		st_time->tm_mday = 1;
	else
		st_time->tm_mday = days;

	st_time->tm_mon = month;
	st_time->tm_year = year;
	st_time->tm_sec = 0;
	st_time->tm_min = 0;
	st_time->tm_hour = 0;
	
	return;
}

static void
free_record(record)
CALLREC *record;
{
	
	if(record->call != NULL) free(record->call);

	if(record->last_name != NULL) free(record->last_name);

	if(record->title != NULL) free(record->title);

	if(record->first_name != NULL) free(record->first_name);

	if(record->middle_name != NULL) free(record->middle_name);

	if(record->birth_date != NULL) free(record->birth_date);

	if(record->license_date != NULL) free(record->license_date);

	if(record->expire_date != NULL) free(record->expire_date);

	if(record->mail_addr1 != NULL) free(record->mail_addr1);

	if(record->mail_city != NULL) free(record->mail_city);

	if(record->mail_state != NULL) free(record->mail_state);

	if(record->zip != NULL) free(record->zip);

	if(record->location1 != NULL) free(record->location1);

	if(record->location2 != NULL) free(record->location2);

	if(record->location3 != NULL) free(record->location3);

	if(record->license_class != NULL) free(record->license_class);

	if(record->prev_call != NULL) free(record->prev_call);

	if(record->prev_class != NULL) free(record->prev_class);

	if( record->extra != NULL) free(record->extra);


}

static void
show_record(current_rec,s)
CALLREC *current_rec;
int	s;
{
char	class;
char	tmpstr[80];
unsigned	bdy,byr;

	usprintf(s,"\n\nCallsign:  %s\n",current_rec->call);

	/* License Class */
	usprintf(s,"Class:     ");
	class = *current_rec->license_class;
	switch(class)
	{
		case	'A':	usprintf(s,"Advanced");
				break;
		case	'E':	usprintf(s,"Extra");
				break;
		case	'G':	usprintf(s,"General");
				break;
		case	'N':	usprintf(s,"Novice");
				break;
		case	'T':	usprintf(s,"Technician");
				break;
		default:	usprintf(s,"Unknown");
	}
	usprintf(s,"\n");

	/* Expire Date */
	sprintf(tmpstr,"%.2s",current_rec->expire_date);

	sscanf(tmpstr,"%d",&byr);
	sprintf(tmpstr,"%s",(current_rec->expire_date+2));
	sscanf(tmpstr,"%d",&bdy);

	month_day_year(byr,bdy,&st_time);

	format_date(&st_time,tmpstr);
	usprintf(s,"Expires:   %s\n",tmpstr);
	usprintf(s,"\n");  /* blank line */

	usprintf(s,"Owner:     %s ",current_rec->first_name);
	if(current_rec->middle_name != NULL)
		usprintf(s,"%s ",current_rec->middle_name);
	usprintf(s,"%s ",current_rec->last_name);
	if(current_rec->title != NULL)
		usprintf(s,"%s",current_rec->title);

	usprintf(s,"\n");


	/* Address formatting */

	usprintf(s,"           %s\n",current_rec->mail_addr1);

	usprintf(s,"           ");	/* line up nxt line */

	if(current_rec->mail_city != NULL)
		usprintf(s,"%s ",current_rec->mail_city);
	if(current_rec->mail_state != NULL)
		usprintf(s,"%s ",current_rec->mail_state);
	if(current_rec->zip != NULL)
		usprintf(s,"%s ",current_rec->zip);
	usprintf(s,"\n");

	usprintf(s,"\n"); /* blank line */

	if(current_rec->prev_call != NULL)
		usprintf(s,"Prev Call: %s\n",current_rec->prev_call);

}




/* check for match of search call against the currently read record */
/* Return -1 if search call is less than the current record */
/* Return 1 if search call is more... */
/* Return 0 if they MATCH */
int
chk4match(srchcall, readcall)
char *srchcall;
char *readcall;
{
int i;
int	sts;

	if(CDBtype == BUCKMASTER)
	{
		/* Special callsign comparison for BUCKMASTER format */

		/* First check Area(number) and suffix  i.e. n(4PCR) */

		sts = strnicmp(&srchcall[2],&readcall[2],4);
		if(sts != 0) return sts;

		/* Now check prefix  i.e. (N)4pcr */
		sts = strnicmp(srchcall,readcall,2);
  		return sts;

	}

	/* If this is normal FCC format data... */
	else
	{
		return (strnicmp(srchcall,readcall,6));

	}
}



/* here disect an input string into it's component parts */
buck_fill_record(brec,record)
BUCKREC	*brec;
CALLREC *record;
{
char	fldbuf[256];
char	*tmpbuf;
int	sts;
int	len;
int	spaces;

    sts = -1;		/* default to fail */
	
	/* get the data fields... and expand as neccessary */		

	/* get the callsign */
	len = endstr(brec->call,6);
	spaces = begstr(brec->call,6);
	tmpbuf = brec->call + spaces;	/* move pointer forward as necessary */
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,tmpbuf,(len-spaces));
	if(strlen(fldbuf))record->call = strdup(fldbuf);

	/* last name */
	len = endstr(brec->last_name,20);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->last_name,len);
	if(strlen(fldbuf))record->last_name = strdup(fldbuf);

	/* title */
	len = endstr(brec->title,4);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->title,len);
	if(strlen(fldbuf))record->title = strdup(fldbuf);

	/* first name */
	len = endstr(brec->first_name,11);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->first_name,len);
	if(strlen(fldbuf))record->first_name = strdup(fldbuf);

	/* middle initial */
	len = endstr(brec->middle_initial,1);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->middle_initial,len);
	if(strlen(fldbuf))record->middle_name = strdup(fldbuf);

	/* birth date */
	len = endstr(brec->birth_date,2);
	memset(fldbuf,'\0',8);
	strncpy(fldbuf,brec->birth_date,len);
	strncpy(&fldbuf[2],"001",3);			/* January 1, 19xx */
										/* since the buckmaster */
										/* has no MO/DAY info*/

	if(strlen(fldbuf))record->birth_date = strdup(fldbuf);

	/* License Date */
	len = endstr(brec->license_date,5);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->license_date,len);
	if(strlen(fldbuf))record->license_date = strdup(fldbuf);

	/* Expire date */
	len = endstr(brec->expire_date,5);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->expire_date,len);
	if(strlen(fldbuf))record->expire_date = strdup(fldbuf);

	/* mailing address line 1... STREET */
	len = endstr(brec->address1,35);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->address1,len);
	if(strlen(fldbuf))record->mail_addr1 = strdup(fldbuf);

	/* mailing address line 2... CITY */
	len = endstr(brec->address2,20);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->address2,len);
	if(strlen(fldbuf))record->mail_city = strdup(fldbuf);

	len = endstr(brec->state,2);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->state,len);
	if(strlen(fldbuf))record->mail_state = strdup(fldbuf);

	len = endstr(brec->zip,5);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->zip,len);
	if(strlen(fldbuf))record->zip = strdup(fldbuf);

	/* Station location record... */
	/* Not available on Buckmaster... */
	memset(fldbuf,'\0',len+1);
	if(strlen(fldbuf))record->location1 = strdup(fldbuf);

	/* Station location record... */
	/* Not available on Buckmaster... */
	memset(fldbuf,'\0',len+1);
	if(strlen(fldbuf))record->location2 = strdup(fldbuf);

	/* Station location record... */
	/* Not available on Buckmaster... */
	memset(fldbuf,'\0',len+1);
	if(strlen(fldbuf))record->location3 = strdup(fldbuf);

	/* License Class */
	len = endstr(brec->license_class,1);
	memset(fldbuf,'\0',len+1);
	strncpy(fldbuf,brec->license_class,len);
	if(strlen(fldbuf))record->license_class = strdup(fldbuf);

	/* Previous Call not available in Buckmaster */
	memset(fldbuf,'\0',len+1);
	if(strlen(fldbuf))record->prev_call = strdup(fldbuf);

	/* Previous Class not available in Buckmaster */
	memset(fldbuf,'\0',len+1);
	if(strlen(fldbuf))record->prev_class = strdup(fldbuf);

	/* unused in Buckmaster */
	memset(fldbuf,'\0',len+1);
	if(strlen(fldbuf)) record->extra = strdup(fldbuf);


	sts = 0;
    return sts;

}


endstr(string,mlen)
char	*string;
{
int	len;
char	*tmp;
int	nonspace = 0;

	tmp = string+(mlen-1);
	len = mlen;
	while(tmp >= string)
	{
		nonspace = 1;
		if(*tmp != ' ') break;
		len--;
		tmp--;
	}
	if(nonspace) return len;	
	else return 0;
}

begstr(string,len)
char	*string;
int		len;
{
char	*tmpstr;
int		count;
int		spaces=0;

	count = len;
	tmpstr = string;
	while((*tmpstr == ' ') && (count > 0))
	{
		count--;
		spaces++;
		tmpstr++;
	}
	return spaces;
}

/* Convert the callsign as specified by the user to a format */
/* suitable for use in the database lookup */
static char	*
convert_call(callsign)
char *callsign;
{
int 	i,len;
char	search_call[20];
int		prefix = 0;

	len = strlen(callsign);

	strcpy(search_call,"            ");		/* init it to spaces */

	/* Buckmaster wants callsigns padded to the left with spaces */
	/* to position the digit at offset 2 */

	/* So we gotta know how many chars are in front of #  */
	/* in the callsign to be looked up */
	for(i=0;i<len;i++)
	{
		if(isascii(callsign[i]))
		{
			if(isdigit(callsign[i]))
			{
				break;
			}
			prefix++;
			/* how many chars in front of # */
		}
	}

	switch(prefix)
	{
		case	1:		strncpy(&search_call[1],callsign,len);
						break;

		default	:		strncpy(&search_call[0],callsign,len);
						break;
	}

	search_call[6] = '\0';		/* Buckmaster callsigns are ALWAYS 6 long */

	/* duplicate and return a ptr to the newly formated search call */
	/* it is the callers responsibility to free the string... */
	return (strdup(search_call));
}
